/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace RhodesProcessorLib
{
    /*! Custom content reader for AngleJointInfo */
    class AngleJointInfoReader : ContentTypeReader<AngleJointInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override AngleJointInfo Read(ContentReader input, AngleJointInfo existingInstance)
        {
            AngleJointInfo jointInfo = new AngleJointInfo();

            jointInfo.Entity1 = input.ReadString();
            jointInfo.Entity2 = input.ReadString();
            jointInfo.TargetAngle = input.ReadSingle();
            jointInfo.MaxImpulse = input.ReadSingle();
            jointInfo.BiasFactor = input.ReadSingle();
            jointInfo.Softness = input.ReadSingle();

            return jointInfo;
        }
    }
}
