/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace RhodesProcessorLib
{
    /*! Custom content reader for CircleCollisionInfo */
    class CircleCollisionInfoReader : ContentTypeReader<CircleCollisionInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override CircleCollisionInfo Read(ContentReader input, CircleCollisionInfo existingInstance)
        {
            CircleCollisionInfo collisionInfo = new CircleCollisionInfo();

            collisionInfo.Type = input.ReadObject<CollisionInfo.CollisionType>();
            collisionInfo.Offset = input.ReadVector2();
            collisionInfo.RotationOffset = input.ReadSingle();
            collisionInfo.Radius = input.ReadSingle();
            collisionInfo.Edges = input.ReadInt32();

            return collisionInfo;
        }
    }
}
