using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;

namespace RhodesProcessorLib
{
    /*! */
    public class EmitterInfo
    {       
        //! general
        private String _spritemap;
        private SpriteBlendMode _blendEffect;
        private List<Vector2> _positions;

		private Vector2 _minVel;
		private Vector2 _maxVel;

        private float _emitLifetime;
        private int _particlePersSec;
        private short _particleAmount;
        private float _particleLifetime;
        private float _particleLifeRandomizer;

        private float _minStartSpeed;
        private float _maxStartSpeed;
        private float _minEndSpeed;
        private float _maxEndSpeed;

        private float _startRotationRange;
        private float _minStartRotSpeed;
        private float _maxStartRotSpeed;
        private float _minEndRotSpeed;
        private float _maxEndRotSpeed;
                
        private Vector2 _minStartSize;
        private Vector2 _maxStartSize;
        private Vector2 _minEndSize;
        private Vector2 _maxEndSize;

        private Vector4 _minStartColor;
        private Vector4 _maxStartColor;
        private Vector4 _minEndColor;
        private Vector4 _maxEndColor;

        public EmitterInfo()
        {
            _positions = new List<Vector2>();

			_minVel = new Vector2();
			_maxVel = new Vector2();
            
            _minStartSize = new Vector2();
            _maxStartSize = new Vector2();
            _minEndSize = new Vector2();
            _maxEndSize = new Vector2();
 
            _minStartColor = new Vector4();
            _maxStartColor = new Vector4();
            _minEndColor = new Vector4();
            _maxEndColor = new Vector4();
        }

        public String Spritemap { get { return _spritemap; } set { _spritemap = value; } }
        public SpriteBlendMode BlendEffect { get { return _blendEffect; } set { _blendEffect = value; } }
        public List<Vector2> Positions { get { return _positions; } set { _positions = value; } }

		public Vector2 MinVel { get { return _minVel; } set { _minVel = value; } }
		public Vector2 MaxVel { get { return _maxVel; } set { _maxVel = value; } }

        public float EmitLifetime { get { return _emitLifetime; } set { _emitLifetime = value; } }
        public int ParticlePersSec { get { return _particlePersSec; } set { _particlePersSec = value; } }
        public short ParticleAmount { get { return _particleAmount; } set { _particleAmount = value; } }
        public float ParticleLifetime { get { return _particleLifetime; } set { _particleLifetime = value; } }
        public float ParticleLifeRandomizer { get { return _particleLifeRandomizer; } set { _particleLifeRandomizer = value; } }

        public float MinStartSpeed { get { return _minStartSpeed; } set { _minStartSpeed = value; } }
        public float MaxStartSpeed { get { return _maxStartSpeed; } set { _maxStartSpeed = value; } }
        public float MinEndSpeed { get { return _minEndSpeed; } set { _minEndSpeed = value; } }
        public float MaxEndSpeed { get { return _maxEndSpeed; } set { _maxEndSpeed = value; } }

        public float StartRotationRange { get { return _startRotationRange; } set { _startRotationRange = value; } }

        public float MinStartRotSpeed { get { return _minStartRotSpeed; } set { _minStartRotSpeed = value; } }
        public float MaxStartRotSpeed { get { return _maxStartRotSpeed; } set { _maxStartRotSpeed = value; } }
        public float MinEndRotSpeed { get { return _minEndRotSpeed; } set { _minEndRotSpeed = value; } }
        public float MaxEndRotSpeed { get { return _maxEndRotSpeed; } set { _maxEndRotSpeed = value; } }
        
        public Vector2 MinStartSize { get { return _minStartSize; } set { _minStartSize = value; } }
        public Vector2 MaxStartSize { get { return _maxStartSize; } set { _maxStartSize = value; } }
        public Vector2 MinEndSize { get { return _minEndSize; } set { _minEndSize = value; } }
        public Vector2 MaxEndSize { get { return _maxEndSize; } set { _maxEndSize = value; } }

        public Vector4 MinStartColor { get { return _minStartColor; } set { _minStartColor = value; } }
        public Vector4 MaxStartColor { get { return _maxStartColor; } set { _maxStartColor = value; } }
        public Vector4 MinEndColor { get { return _minEndColor; } set { _minEndColor = value; } }
        public Vector4 MaxEndColor { get { return _maxEndColor; } set { _maxEndColor = value; } }

    }
}
