/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for CollisionInfo */
    [ContentTypeWriter]
    class EmitterInfoWriter : ContentTypeWriter<EmitterInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, EmitterInfo value)
        {
            output.Write( value.Spritemap );
            output.WriteObject<SpriteBlendMode>( value.BlendEffect );
            output.WriteObject( value.Positions );

			output.Write(value.MinVel);
			output.Write(value.MaxVel);

            output.Write( value.EmitLifetime );
            output.Write( value.ParticlePersSec );
            output.Write( value.ParticleAmount );
            output.Write( value.ParticleLifetime );
            output.Write( value.ParticleLifeRandomizer );

            output.Write( value.MinStartSpeed );
            output.Write( value.MaxStartSpeed );
            output.Write( value.MinEndSpeed );
            output.Write( value.MaxEndSpeed );

            output.Write( value.StartRotationRange );

            output.Write( value.MinStartRotSpeed );
            output.Write( value.MaxStartRotSpeed );
            output.Write( value.MinEndRotSpeed );
            output.Write( value.MaxEndRotSpeed );

            output.Write( value.MinStartSize );
            output.Write( value.MaxStartSize );
            output.Write( value.MinEndSize );
            output.Write( value.MaxEndSize );

            output.Write(value.MinStartColor);
            output.Write(value.MaxStartColor);
            output.Write(value.MinEndColor);
            output.Write(value.MaxEndColor);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.EmitterInfoReader, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.EmitterInfo, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
