/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;

namespace RhodesProcessorLib
{
    /*! Custom content JointInfo */
    public abstract class JointInfo
    {
        enum Type
        {
            Revolute = 0,
            Angle = 1
        }

        private String _entity1;
        private String _entity2;
        private float _biasFactor;
        private float _softness;

        public JointInfo()
        {
            _biasFactor = 0.0f;
            _softness = 0.0f;
        }

        public String Entity1 { get { return _entity1; } set { _entity1 = value; } }
        public String Entity2 { get { return _entity2; } set { _entity2 = value; } }
        public float BiasFactor { get { return _biasFactor; } set { _biasFactor = value; } }
        public float Softness { get { return _softness; } set { _softness = value; } }
    }

    /*! Custom content RevoluteJointInfo */
    public class RevoluteJointInfo : JointInfo
    {
        private Vector2 _offset;

        public RevoluteJointInfo() : base() { }

        public Vector2 Offset { get { return _offset; } set { _offset = value; } }
    }

    /*! Custom content AngleJointInfo */
    public class AngleJointInfo : JointInfo
    {
        private float _targetAngle;
        private float _maxImpulse;

        public AngleJointInfo() : base() 
        {
            _targetAngle = 0.0f;
            _maxImpulse = 0.0f;
        }

        public float TargetAngle { get { return _targetAngle; } set { _targetAngle = value; } }
        public float MaxImpulse { get { return _maxImpulse; } set { _maxImpulse = value; } }
    }
}
