/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace RhodesProcessorLib
{
    /*! Custom content reader for RectangleBodyInfo */
    class RectangleBodyInfoReader : ContentTypeReader<RectangleBodyInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override RectangleBodyInfo Read(ContentReader input, RectangleBodyInfo existingInstance)
        {
            RectangleBodyInfo bodyInfo = new RectangleBodyInfo();

            bodyInfo.Type = input.ReadObject<BodyInfo.BodyType>();
            bodyInfo.Width = input.ReadSingle();
            bodyInfo.Height = input.ReadSingle();
            
            return bodyInfo;
        }
    }
}
