/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace RhodesProcessorLib
{
    /*! Custom content reader for RectangleCollisionInfo */
    class RectangleCollisionInfoReader : ContentTypeReader<RectangleCollisionInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override RectangleCollisionInfo Read(ContentReader input, RectangleCollisionInfo existingInstance)
        {
            RectangleCollisionInfo collisionInfo = new RectangleCollisionInfo();

            collisionInfo.Type = input.ReadObject<CollisionInfo.CollisionType>();
            collisionInfo.Offset = input.ReadVector2();
            collisionInfo.RotationOffset = input.ReadSingle();
            collisionInfo.Width = input.ReadSingle();
            collisionInfo.Height = input.ReadSingle();
            
            return collisionInfo;
        }
    }
}
