/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for RectangleCollisionInfo */
    [ContentTypeWriter]
    class RectangleCollisionInfoWriter : ContentTypeWriter<RectangleCollisionInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, RectangleCollisionInfo value)
        {
            output.WriteObject(value.Type);
            output.Write(value.Offset);
            output.Write(value.RotationOffset);
            output.Write(value.Width);
            output.Write(value.Height);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.RectangleCollisionInfoReader, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.RectangleCollisionInfo, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
