/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace SedohrProcessorLib
{
    /*! Custom content writer for CircleBodyInfo */
    [ContentTypeWriter]
    class GraphicsInfoWriter : ContentTypeWriter<GraphicsInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, GraphicsInfo value)
        {
            output.Write(value.Filename);
            output.Write(value.Position);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "SedohrProcessorLib.GraphicsInfoReader, SedohrProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "SedohrProcessorLib.GraphicsInfo, SedohrProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
