using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using rhodes.graphics;

namespace SedohrProcessorLib
{
    /*! Custom content reader for LayerInfo */
    class LayerInfoReader : ContentTypeReader<LayerInfo>
    {
        protected override LayerInfo Read(ContentReader input, LayerInfo existingInstance)
        {
            LayerInfo layerInfo = new LayerInfo();

            layerInfo.Depth = input.ReadInt32();
            layerInfo.Proportion = input.ReadSingle();
            layerInfo.Statics = input.ReadObject<List<String>>();
            layerInfo.SimpleObjects = input.ReadObject<List<String>>();
            layerInfo.CompoundObjects = input.ReadObject<List<String>>();
            layerInfo.Graphics = input.ReadObject<List<GraphicsInfo>>();
            layerInfo.LightInfo = input.ReadObject<List<LightInfo>>();

            return layerInfo;
        }        
    }
}
