using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace SedohrProcessorLib
{
    [ContentTypeWriter]
    class LightInfoWriter : ContentTypeWriter<LightInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, LightInfo value)
        {
            output.Write(value.Position);
            output.Write(value.Attenuation);
            output.Write(value.Color);
            output.Write(value.IsAttenuated);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "SedohrProcessorLib.LightInfo, SedohrProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "SedohrProcessorLib.LightInfoReader, SedohrProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
