uniform extern texture colorTexture;
sampler colorSampler = sampler_state
{
    Texture = <colorTexture>;
    mipfilter = LINEAR; 
};

struct VS_OUTPUT
{
    float4 position	: POSITION;
    float2 uv0		: TEXCOORD0;
};
 
VS_OUTPUT genericPost_vs(
    float3 position : POSITION, 
    float2 uv0 : TEXCOORD0 )
{
    VS_OUTPUT output = (VS_OUTPUT)0;

    output.position = float4(position,1);
    output.uv0 = uv0;

    return output;
}

float4 genericPost_ps(VS_OUTPUT vsout) : COLOR
{
    return tex2D(colorSampler, vsout.uv0);
}

technique genericPost
{
    pass P0
    {
        vertexShader = compile vs_2_0 genericPost_vs();
        pixelShader  = compile ps_2_0 genericPost_ps();
    }
}