/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;

namespace rhodes.graphics
{
    /*! Chains composite(s) together for post processing */
    public class CompositeChain
    {
        List<Composite> _chain;
		SortedDictionary<String, Composite> _compositeMap;

        public CompositeChain()
        {
            _chain = new List<Composite>();
        }

        /*! Renders all composite(s) in order */
        public void render()
        {
            for (int n = 0; n < _chain.Count; ++n)
            {
                if ((_chain[n].RenderMode == Composite.PassType.Pass) && (n != 0))
                {
                    _chain[n].InputTarget = _chain[n - 1].OutputTarget;
                }

                _chain[n].render();               
            }
        }

        /*! Add a comoposite to the chain 
         * \param composite The composite */
        public void addComposite(Composite composite)
        {
            _chain.Add(composite);
        }

        /*! Gets a composite in the chain via an index 
         * \param index The index of where the composite is.
         * \return Returns a composite */
        public Composite getComposite(int index)
        {
            return null;
        }

        /*! Clears the composite chain. */
        public void clearComposite()
        {
            _chain.Clear();
        }

        /*! Properties */
        public List<Composite> Chain { get { return _chain; } }
		public SortedDictionary<String, Composite> CompositeMap { get { return _compositeMap; } }
    }
}
