/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace rhodes.graphics
{
    /*! Manages and loads effect files */
    class EffectResourceManager : ResourceManager<Effect>
    {
        private static volatile EffectResourceManager _instance;
        private static object _syncRoot = new Object();

        //! Constructor
        private EffectResourceManager() : base()
        {
            _resources.Add("BasicEffect", new BasicEffect(GraphicsCore.getSingleton.Graphics.GraphicsDevice, null));
        }

        /*! Returns singleton instance of the EffectResourceManager */
        public static EffectResourceManager getSingleton
        {
            get
            {
                if (_instance == null)
                {
                    lock (_syncRoot)
                    {
                        if (_instance == null)
                            _instance = new EffectResourceManager();
                    }
                }

                return _instance;
            }
        }
    }
}
