/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace rhodes.graphics
{
    //! SpriteMapReader
    /*!
      Reads in the xnb files for sprite maps.
     */
    class SpriteMapReader: ContentTypeReader<SpriteMap>
    {
        protected override SpriteMap Read( ContentReader input, SpriteMap existingInstance )
        {
            Texture2D diffuse = TextureResourceManager.getSingleton.load(input.ReadString().Replace(".png",""));
            Texture2D normal = TextureResourceManager.getSingleton.load(input.ReadString().Replace(".png",""));

            short width = input.ReadInt16();
            short height = input.ReadInt16();

            int frameCount = input.ReadInt32();
            
            List<Point> frames = input.ReadObject<List<Point>>();

            Dictionary<String,Point> animations = input.ReadObject<Dictionary<String,Point>>();
            
            return new SpriteMap(width, height, frameCount, diffuse, normal, frames, animations);
        }
    }
}
