/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace rhodes.physics
{
    /*! A physics body in Farseer */
    public class PhysicsBody
    {
        private String _name;
        private Body _body;
        private List<Geom> _geomList; // a body can have multiple collision geometry

        public PhysicsBody()
        {
            _geomList = new List<Geom>();
        }

        public PhysicsBody(String name, Body body, List<Geom> geomList)
        {
            _name = name;
            _body = body;
            _geomList = geomList;
        }

        public String Name { get { return _name; } }
        public Vector2 Position { get { return _body.Position; } }
        public float Rotation { get { return _body.Rotation; } }
        public Body Body { get { return _body; } }
        public List<Geom> GeomList { get { return _geomList; } }
    }
}
