using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using rhodes.graphics;

namespace sedohr.weapon
{
	/// <summary>
	/// A pistol weapon that shoots a bullet.
	/// Author: Robert Yates and Andrew Kane
	/// </summary>
	class Pistol : ProjectileWeapon
	{
		#region Constant

		/// <summary>
		/// The amount of time (in seconds) required between the pistol shots
		/// </summary>
		private const float PISTOL_COOLDOWN = 0.3f;

		#endregion

		#region Constructor

		/// <summary>
		/// Pistol constructor
		/// (Visibility defaults to false.)
		/// </summary>
		/// <param name="playerIndex">The index of the player firing this pistol</param>
        public Pistol(PlayerIndex playerIndex) : base(playerIndex)
        {
            // create pistol entity
            cooldownAmount = PISTOL_COOLDOWN;
			weaponName = "pistol player" + ((int)playerIndex + 1);
			weaponGenre = weaponType.PISTOL;
            weaponSprite = SpriteManager.getSingleton.load(weaponName, "assets/sprites/pistolWeapon");
			Visible = false;
			
		}

		#endregion
	}
}
